package date

import (
  "strconv"
  . "gokurs/obj"
)
type
  date struct {
          day,
        month,
         year uint
              }

func New() *date {
/*
  d:= new (date)
  x.day, x.month, x.year = 0, 0, 0 // überflüssig
  return d
*/
  return new(date)
}

func (x *date) imp (D Any) *date {
  y, ok:= D.(*date)
  if ! ok { panic("Typfehler") }
  return y
}

func (x *date) Get() (uint, uint, uint) {
  return x.day, x.month, x.year
}

func (x *date) leapyear() bool {
  return x.year % 4 == 0 && x.year % 100 != 0 ||
         x.year % 400 == 0
}

func (x *date) isValid () bool {
  if x.day < 1 { return true }
  if x.year < 1583 { return false }
  if x.month == 2 {
    if x.leapyear() {
      return x.day <= 29
    }
    return x.day <= 28
  }
  if x.month / 8 == x.month % 2 { // Fingerknöchelalgorithmus
    return x.day <= 31
  }
  return x.day <= 30
}

func (x *date) Next() {
  x.day++
  if ! x.isValid() {
    x.day = 1
    x.month++
  }
  if ! x.isValid() {
    x.month = 1
    x.year++
  }
}

func (x *date) Set (t, m, j uint) {
  x.day, x.month, x.year = t, m, j
  if ! x.isValid () {
    x.day = 0
  }
}

func (x *date) Clr() {
  x.day = 0
}

func (x *date) Empty() bool {
  return x.day == 0
}

func (x *date) Eq (Y Any) bool {
  y:= x.imp(Y)
  if x.day == 0 { return y.day == 0 }
  return x.day == y.day &&
         x.month == y.month &&
         x.year == y.year
}

func (x *date) Copy (Y Any) {
  y:= x.imp(Y)
  x.day, x.month, x.year = y.day, y.month, y.year
}

func (x *date) Clone() Any {
  y:= New()
  y.Copy (x)
  return y
}

func (x *date) Less (Y Any) bool {
  y:= x.imp(Y)
  if x.day == 0 { // leeres Datum ist kleiner als nichtleeres
    return y.day > 0
  }
  if y.day == 0 { return false }
  if x.year == y.year {
    if x.month == y.month {
      return x.day < y.day
    }
    return x.month < y.month
  }
  return x.year < y.year
}

func (x *date) String() string {
  if x.day == 0 { return "" }
  return strconv.Itoa(int(x.day)) + "." +
         strconv.Itoa(int(x.month)) + "." +
         strconv.Itoa(int(x.year))
}
