package seq

import (
  . "gokurs/obj"
)
type
  Sequence interface {

  Object

// Liefert die Anzahl der Elemente in x.
  Num() uint

// i ist an der Position von x eingefügt;
// die Position von x ist um 1 erhöht.
  Ins (i Any)

// Pre: Die Position von x ist < x.Num ().
// Das Element an der Position von x ist durch i ersetzt;
// die Position von x ist unverändert.
  Put (i Any)

// Pre: p <= x.Num()
// x hat die Position p.
  Seek (p uint)

// Liefert die Position von x.
  Pos() uint

  Trav (f Func)

// Liefert genau dann true, wenn a in x enthalten ist.
  Ex (a Any) bool

// Pre: x hat eine Position <= x.Num().
// Liefert das Element an der Position von x.
  Get() Any

// Pre: x hat eine Position <= x.Num().
// Liefert das Element an der Position von x;
// dieses Element ist aus x entfernt.
// TODO Spec Was ist mit der Position ?
  Del() Any

// Y besteht aus allen denjenigen Elementen von x,
// auf die p zutrifft (in unveränderter Reihenfolge).
  Filter (Y Sequence, p Pred)
}
